CREATE TABLE HCL 
    ( 
     HCL_ID BIGINT  NOT NULL 
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 
;



ALTER TABLE HCL 
    ADD CONSTRAINT HCL_PK PRIMARY KEY ( HCL_ID ) 
;



CREATE TABLE HCL_CODE 
    ( 
     HCODE_ID BIGINT  NOT NULL , 
     PARENT_HCODE_ID BIGINT , 
     LCD_ID BIGINT  NOT NULL , 
     H_ID BIGINT  NOT NULL , 
     LEVEL_ID BIGINT 
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 
;



ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_PK PRIMARY KEY ( HCODE_ID ) 
;



CREATE TABLE HIERARCHY 
    ( 
     H_ID BIGINT  NOT NULL , 
     HCL_ID BIGINT  NOT NULL 
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 
;



ALTER TABLE HIERARCHY 
    ADD CONSTRAINT HIERARCHY_PK PRIMARY KEY ( H_ID ) 
;



CREATE TABLE HLEVEL 
    ( 
     LEVEL_ID BIGINT  NOT NULL , 
     H_ID BIGINT  NOT NULL , 
     PARENT_LEVEL_ID BIGINT 
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 
;



ALTER TABLE HLEVEL 
    ADD CONSTRAINT LEVEL_PK PRIMARY KEY ( LEVEL_ID ) 
;




ALTER TABLE HCL 
    ADD CONSTRAINT HCL_ARTEFACT_FK FOREIGN KEY 
    ( 
     HCL_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
    ON DELETE CASCADE 
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_ARTEFACT_FK FOREIGN KEY 
    ( 
     HCODE_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_DSD_CODE_FK FOREIGN KEY 
    ( 
     LCD_ID
    ) 
    REFERENCES DSD_CODE 
    ( 
     LCD_ID
    ) 
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_HCL_CODE_FK FOREIGN KEY 
    ( 
     PARENT_HCODE_ID
    ) 
    REFERENCES HCL_CODE 
    ( 
     HCODE_ID
    ) 
    ON DELETE SET NULL
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_HIERARCHY_FK FOREIGN KEY 
    ( 
     H_ID
    ) 
    REFERENCES HIERARCHY 
    ( 
     H_ID
    ) 
    ON DELETE CASCADE 
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_LEVEL_FK FOREIGN KEY 
    ( 
     LEVEL_ID
    ) 
    REFERENCES HLEVEL 
    ( 
     LEVEL_ID
    ) 
    ON DELETE SET NULL
;


ALTER TABLE HIERARCHY 
    ADD CONSTRAINT HIERARCHY_ARTEFACT_FK FOREIGN KEY 
    ( 
     H_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
;


ALTER TABLE HIERARCHY 
    ADD CONSTRAINT HIERARCHY_HCL_FK FOREIGN KEY 
    ( 
     HCL_ID
    ) 
    REFERENCES HCL 
    ( 
     HCL_ID
    ) 
    ON DELETE CASCADE 
;


ALTER TABLE HLEVEL 
    ADD CONSTRAINT LEVEL_ARTEFACT_FK FOREIGN KEY 
    ( 
     LEVEL_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
;


ALTER TABLE HLEVEL 
    ADD CONSTRAINT LEVEL_HIERARCHY_FK FOREIGN KEY 
    ( 
     H_ID
    ) 
    REFERENCES HIERARCHY 
    ( 
     H_ID
    ) 
    ON DELETE CASCADE 
;


ALTER TABLE HLEVEL 
    ADD CONSTRAINT LEVEL_LEVEL_FK FOREIGN KEY 
    ( 
     PARENT_LEVEL_ID
    ) 
    REFERENCES HLEVEL 
    ( 
     LEVEL_ID
    ) 
    ON DELETE SET NULL
;


ALTER TABLE ARTEFACT ADD VALID_FROM VARCHAR(50) NULL
;

ALTER TABLE ARTEFACT ADD VALID_TO VARCHAR(50) NULL
;

update DB_VERSION SET VERSION = '2.5'
;

ALTER TABLE ARTEFACT MODIFY ID VARCHAR(50) NULL
;

ALTER TABLE ARTEFACT MODIFY AGENCY VARCHAR(50) NULL
;

ALTER TABLE DSD_CODE DROP FOREIGN KEY FK_DSD_CODE_DSD_CODE 
;

ALTER TABLE DSD_CODE ADD CONSTRAINT FK_DSD_CODE_DSD_CODE 
	FOREIGN KEY(PARENT_CODE_ID) REFERENCES DSD_CODE (LCD_ID)
	ON DELETE SET NULL
;